# Every Programmer Should Know :thinking:
A collection of (mostly) technical things every software developer should know.  

:point_up: *These are resources I can recommend to every programmer regardless of their skill level or tech stack*

Highly opinionated :bomb:. Not backed by science.  
Comes in no particular order :recycle:

U like it? :star: it and [share](https://twitter.com/mr_mig_by/status/900735231552098306) with a friendly developer! 
U don't like it? [Watch the doggo](https://twitter.com/RespectfulMemes/status/900147758845308930) :dog:

*P.S. You [don't need to know](https://xkcd.com/1050/) all of that by heart to be a programmer.  
But knowing the stuff will help you become better! :muscle:*

---- 

### Introduction
- :movie_camera: [Map of Computer Science](https://www.youtube.com/watch?v=SzJ46YA_RaA) 

### Falsehoods
- [Awesome Falsehoods](https://github.com/kdeldycke/awesome-falsehood)  
  💊 Curated list of falsehoods programmers believe in.    
  Check for things you do not know about Strings, Addresses, Names, Numbers, Emails, Timezones and Dates and more.

### Algorithms
- [Big O Cheatsheet](http://bigocheatsheet.com/)
- :book: [Grokking Algorithms](https://www.goodreads.com/book/show/22847284-grokking-algorithms-an-illustrated-guide-for-programmers-and-other-curio)
- [Sorting Algorithms](https://visualgo.net/en/sorting)

### Numbers
- :page_facing_up: [Floating Point Guide](http://floating-point-gui.de/)
- :page_facing_up: [Basic Number Theory Every Programmer Should Know...](https://www.codechef.com/wiki/tutorial-number-theory/)

### Strings
- :page_facing_up: [Unicode and Character Sets](http://www.joelonsoftware.com/articles/Unicode.html)
- [Homoglyphs](https://github.com/codebox/homoglyph/)
- [Unicode Common Locale Data Repository](http://cldr.unicode.org/)

### Latency 
- [Interactive Latency Infographics](https://people.eecs.berkeley.edu/~rcs/research/interactive_latency.html)
- :page_facing_up: [Latency Numbers Every Programmer Should Know](https://gist.github.com/jboner/2841832)

### Time
- :page_facing_up: [Some notes about time](https://unix4lyfe.org/time/?v=1)

### Memory
- :page_facing_up: [What every Programmer should know about memory](http://lwn.net/Articles/250967/)

### Distributed Systems
- :book: [Designing Data-Intensive Applications](https://www.goodreads.com/book/show/23463279-designing-data-intensive-applications)
- :scroll: [Designs, Lessons and Advice from Building Large Distributed Systems](http://www.cs.cornell.edu/projects/ladis2009/talks/dean-keynote-ladis2009.pdf)
- :scroll: [Time, Clocks and the Ordering of Events in a Distributed System](https://www.microsoft.com/en-us/research/publication/time-clocks-ordering-events-distributed-system/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Flamport%2Fpubs%2Ftime-clocks.pdf)
- :page_facing_up: [There is No Now](http://queue.acm.org/detail.cfm?id=2745385)
- :page_facing_up: [Jepsen: how different databases behave under partition](https://aphyr.com/tags/jepsen)
- :scroll: [Fallacies of Distributed Computing Explained](http://www.rgoarchitects.com/Files/fallacies.pdf)

### RegExp
- [RegexHQ](https://github.com/regexhq)

### Security
- :book: [Security Programming](https://www.dwheeler.com/secure-programs/)
- :page_facing_up: [Rolling Your Own Crypto](http://loup-vaillant.fr/articles/rolling-your-own-crypto)
- :book: [Foundations of Security: What Every Programmer Needs to Know ](https://www.goodreads.com/book/show/128003.Foundations_of_Security)
- [OWASP Top 10](https://www.owasp.org/index.php/Category:OWASP_Top_Ten_Project)

### SEO
- :page_facing_up: [What Every Programmer Should Know About SEO](http://katemats.com/what-every-programmer-should-know-about-seo/)

### Architecture
- :scroll: [A Field Guide to Boxology](http://web.cs.wpi.edu/~cs562/s98/pdf/Boxology.pdf)
- :scroll: [Out of the Tar Pit](https://github.com/papers-we-love/papers-we-love/blob/master/design/out-of-the-tar-pit.pdf?raw=true)
- :scroll: [No Silver Bullet — Essence and Accidents of Software Engineering](http://faculty.salisbury.edu/~xswang/Research/Papers/SERelated/no-silver-bullet.pdf)
- :movie_camera: [Growing a Language](https://www.youtube.com/watch?v=_ahvzDzKdB0)
- :movie_camera: [CQRS and Event Sourcing](https://www.youtube.com/watch?v=JHGkaShoyNs)
- :book: [Practical Object Oriented Design in Ruby](http://www.poodr.com/)
- :movie_camera: [Evolutionary Software Architectures](https://www.youtube.com/watch?v=CglSFhwbI3s)

### Practices
- :book: [Working Effectively with Legacy Code](https://www.goodreads.com/book/show/44919.Working_Effectively_with_Legacy_Code)
- :book: [Test Driven Development: By Example](https://www.goodreads.com/book/show/387190.Test_Driven_Development)
- :white_check_mark: [Going To Production Checklist](https://github.com/mr-mig/going-to-production)
- :book: [Release It!](https://www.goodreads.com/book/show/1069827.Release_It_)
- :book: [Professor Frisby's Mostly Adequate Guide to Functional Programming](https://drboolean.gitbooks.io/mostly-adequate-guide/content/)
- :book: [SICP: Structure and Interpretation of Computer Programs](https://www.goodreads.com/book/show/43713.Structure_and_Interpretation_of_Computer_Programs)
- :page_facing_up: [Thirteen Ways of Looking at a Turtle](https://fsharpforfunandprofit.com/posts/13-ways-of-looking-at-a-turtle-3/)
- :scroll: [Programming Paradigms for Dummies: What Every Programmer Should Know](https://www.info.ucl.ac.be/~pvr/VanRoyChapter.pdf)

### Career 
- :page_facing_up: [10 Things Every Programmer Should Know For Their First Job](http://www.applematters.com/article/10-things-every-programmer-should-know-for-their-first-job/)
- :page_facing_up: [How Much Do Software Engineers Really Make in Each City?](https://www.codementor.io/blog/best-cities-software-engineer-earnings-271vpf599k)
- :page_facing_up: [Software Engineers Tenure in San Francisco](https://hackerlife.co/blog/san-francisco-large-corporation-employee-tenure)
- [Software Engineering 101](https://slides.com/mr-mig/se101)
- :book: [The Passionate Programmer](https://www.goodreads.com/book/show/6399113-the-passionate-programmer)
- :book: [Soft Skills: The software developer's life manual](https://www.goodreads.com/book/show/23232941-soft-skills)
- :book: [Programming Beyond Practices: Be More Than Just a Code Monkey](https://www.goodreads.com/book/show/29895093-programming-beyond-practices)
- [A list of European Investors](https://docs.google.com/spreadsheets/d/1hfl67rI0Pk_hSm0GIX0QByW4NgfAH-cEmMa4N6UoO1w/edit#gid=1203141194)
- :page_facing_up: [Ten Rules for Negotiating a Job Offer](https://medium.freecodecamp.com/ten-rules-for-negotiating-a-job-offer-ee17cccbdab6)
- :page_facing_up: [How To Interview As a Developer Candidate](https://medium.freecodecamp.com/how-to-interview-as-a-developer-candidate-b666734f12dd)
- :book: [How To Be A STAR Engineer](http://vlsicad.ucsd.edu/Research/Advice/star_engineer.pdf)
- :page_facing_up: [TL;DR; Stock Options](https://tldroptions.io/)
- :page_facing_up: [Equity 101 for Startup Employees](https://blog.esharesinc.com/equity-101-stock-option-basics/)
- :book: [Cracking the Coding Interview: 150 Programming Questions and Solutions](https://www.goodreads.com/book/show/12544648-cracking-the-coding-interview)
- :fire: [Everything you need to know to get the job](https://github.com/kdn251/interviews)

### Engineering Philosophy
- :movie_camera: [Simple Made Easy](https://www.infoq.com/presentations/Simple-Made-Easy)
- :page_facing_up: [Speed In Software Development](https://www.targetprocess.com/articles/speed-in-software-development/)
- :movie_camera: [The Myth of the Genius Programmer](https://www.youtube.com/watch?v=0SARbwvhupQ&feature=youtu.be)
- :movie_camera: [Making Badass Developers](https://www.youtube.com/watch?v=FKTxC9pl-WM&t=2s)
- :page_facing_up: [The Ten Rules of a Zen Programmer](https://www.zenprogrammer.org/en/the10rulesofazenprogrammer.html)

### Soft Skills
- :book: [Difficult Conversations](https://www.goodreads.com/book/show/774088.Difficult_Conversations)
- :book: [Crucial Conversations](https://www.goodreads.com/book/show/15014.Crucial_Conversations)
- :book: [How to Win Friends and Influence People](https://www.goodreads.com/book/show/4865.How_to_Win_Friends_and_Influence_People)

### Papers on Programming 
- :heart: [Papers We Love](https://github.com/papers-we-love/papers-we-love) 
- :newspaper: [The Morning Paper](https://blog.acolyer.org/)

### Free Books on Programming
- :books: [Free Programming Books](https://github.com/EbookFoundation/free-programming-books)

### Services :zap:
- [Free For Dev](https://github.com/ripienaar/free-for-dev/blob/master/README.md)
- [Public APIs](https://github.com/abhishekbanthia/Public-APIs)
- [The Noun Project](https://thenounproject.com/)
- [Without Coding](https://www.producthunt.com/@jurica87/collections/without-coding)
- [Simpleicons](https://simpleicons.org/)

### Where To Look For Further Info
- [GeeksForGeeks](http://www.geeksforgeeks.org/)
- [Dev.To](https://dev.to/)
- [Stackoverflow](https://stackoverflow.com/)
